import { IPromise } from '@pilotlab/result';
import { AttributeBase, IAttributeChangeOptions, IAttributeFactory, Attributes } from '@pilotlab/data';
import { IAnimationEaseFunction } from '@pilotlab/animation';
import { Signal } from '@pilotlab/signals';
import StatesBase from './statesBase';
import IState from './interfaces/iState';
export declare abstract class StateBase<TState extends StateBase<any>> extends AttributeBase<any, TState, StatesBase<TState>, TState> implements IState {
    protected constructor(factory: IAttributeFactory, settings?: any, label?: string, key?: string);
    readonly isEmpty: boolean;
    isOnStack: boolean;
    internalIsOnStack: boolean;
    isCurrent: boolean;
    internalIsCurrent: boolean;
    readonly previous: TState;
    internalPrevious: TState;
    durationSpeed: any;
    protected p_durationSpeed: any;
    ease: IAnimationEaseFunction;
    protected p_ease: IAnimationEaseFunction;
    readonly settings: Attributes;
    resetCompleted: Signal<TState>;
    reset(value?: any, changeOptions?: IAttributeChangeOptions): this;
    protected onReset(): void;
    entered: Signal<TState>;
    internalEnter(value?: any, changeOptions?: IAttributeChangeOptions): this;
    protected onBeforeEnter(): void;
    protected onEntered(): void;
    exited: Signal<TState>;
    internalExit(changeOptions?: IAttributeChangeOptions): this;
    protected onBeforeExit(result: IPromise<any>): IPromise<any>;
    protected onExited(): void;
    enter(value?: any, changeOptions?: IAttributeChangeOptions): this;
    exit(value?: any, changeOptions?: IAttributeChangeOptions): this;
    push(value?: any, changeOptions?: IAttributeChangeOptions, isEnterState?: boolean, isExitPrevious?: boolean, isPopAll?: boolean): this;
    popAllAbove(changeOptions?: IAttributeChangeOptions, isExitEach?: boolean, isEnterState?: boolean): this;
    popAllAboveInclusive(changeOptions?: IAttributeChangeOptions, isExitEach?: boolean, isEnterPrevious?: boolean): this;
    protected p_checkPrincipals(): void;
}
export default StateBase;
